import { ReactElement } from "react";
import * as Types from "./types";
export declare type WithLoaderArgs<P extends unknown, R extends unknown, A = never> = {
    useLoader: Types.UseLoader<A, R>;
    arg?: (props: P) => A;
    onLoading?: ReactElement;
};
export declare type Component<P extends Record<string, unknown>> = (props: P) => ReactElement;
export declare const withLoader: <P extends Record<string, unknown>, R extends unknown, A = never>(args: WithLoaderArgs<P, R, A>, Component: Component<P & {
    loaderData: R;
}>) => Component<P>;
